# Copyright (c) 2016 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/audio/audioMessageTypes.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ -o ../generated/cladPython// clad/audio/audioMessageTypes.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.AudioEngine = msgbuffers.Namespace()
Anki.AudioEngine.Multiplexer = msgbuffers.Namespace()

class AudioCallbackFlag(object):
  "Automatically-generated uint_8 enumeration."
  EventNone     = 0x0
  EventDuration = 0x1
  EventMarker   = 0x2
  EventComplete = 0x4
  EventAll      = 0x7
  EventError    = 0xff

Anki.AudioEngine.Multiplexer.AudioCallbackFlag = AudioCallbackFlag
del AudioCallbackFlag


class CurveType(object):
  "Automatically-generated uint_8 enumeration."
  Linear         = 0
  SCurve         = 1
  InversedSCurve = 2
  Sine           = 3
  SineReciprocal = 4
  Exp1           = 5
  Exp3           = 6
  Log1           = 7
  Log3           = 8

Anki.AudioEngine.Multiplexer.CurveType = CurveType
del CurveType


