# Copyright (c) 2016 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/animationTrigger.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ -o ../generated/cladPython// clad/types/animationTrigger.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class AnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  AcknowledgeFaceInitPause              = 0
  AcknowledgeFaceNamed                  = 1
  AcknowledgeFaceUnnamed                = 2
  AcknowledgeObject                     = 3
  AskToBeRightedLeft                    = 4
  AskToBeRightedRight                   = 5
  BlockReact                            = 6
  BuildPyramidFirstBlockOnSide          = 7
  BuildPyramidFirstBlockUpright         = 8
  BuildPyramidLookForFace               = 9
  BuildPyramidReactToBase               = 10
  BuildPyramidSecondBlockOnSide         = 11
  BuildPyramidSecondBlockUpright        = 12
  BuildPyramidSuccess                   = 13
  BuildPyramidThankUser                 = 14
  BuildPyramidThirdBlockOnSide          = 15
  BuildPyramidThirdBlockUpright         = 16
  CantHandleTallStack                   = 17
  PatternGuessNewIdea                   = 18
  PatternGuessThinking                  = 19
  ConnectWakeUp                         = 20
  CozmoSaysGetIn                        = 21
  CozmoSaysGetOut                       = 22
  CozmoSaysSpeakGetInShort              = 23
  CozmoSaysSpeakGetInMedium             = 24
  CozmoSaysSpeakGetInLong               = 25
  CozmoSaysSpeakGetOutShort             = 26
  CozmoSaysSpeakGetOutMedium            = 27
  CozmoSaysSpeakGetOutLong              = 28
  CozmoSaysSpeakLoop                    = 29
  CozmoSaysBadWord                      = 30
  CozmoSaysIdle                         = 31
  CubeMovedSense                        = 32
  CubeMovedUpset                        = 33
  CubePounceFake                        = 34
  CubePounceGetIn                       = 35
  CubePounceGetOut                      = 36
  CubePounceGetReady                    = 37
  CubePounceGetUnready                  = 38
  CubePounceIdleLiftDown                = 39
  CubePounceIdleLiftUp                  = 40
  CubePounceLoseHand                    = 41
  CubePounceLoseRound                   = 42
  CubePounceLoseSession                 = 43
  CubePouncePounceClose                 = 44
  CubePouncePounceNormal                = 45
  CubePounceWinHand                     = 46
  CubePounceWinRound                    = 47
  CubePounceWinSession                  = 48
  DemoSpeedTapCozmoWin                  = 49
  DemoSpeedTapCozmoLose                 = 50
  DizzyReactionHard                     = 51
  DizzyReactionMedium                   = 52
  DizzyReactionSoft                     = 53
  DizzyShakeLoop                        = 54
  DizzyShakeStop                        = 55
  DizzyStillPickedUp                    = 56
  DriveEndAngry                         = 57
  DriveEndDefault                       = 58
  DriveEndLaunch                        = 59
  DriveLoopAngry                        = 60
  DriveLoopDefault                      = 61
  DriveLoopLaunch                       = 62
  DriveStartAngry                       = 63
  DriveStartDefault                     = 64
  DriveStartLaunch                      = 65
  DroneModeBackwardDrivingEnd           = 66
  DroneModeBackwardDrivingLoop          = 67
  DroneModeBackwardDrivingStart         = 68
  DroneModeCliffEvent                   = 69
  DroneModeForwardDrivingEnd            = 70
  DroneModeForwardDrivingLoop           = 71
  DroneModeForwardDrivingStart          = 72
  DroneModeGetIn                        = 73
  DroneModeGetOut                       = 74
  DroneModeIdle                         = 75
  DroneModeKeepAlive                    = 76
  DroneModeTurboDrivingStart            = 77
  FacePlantRoll                         = 78
  FacePlantRollArmUp                    = 79
  FailedToRightFromFace                 = 80
  FistBumpIdle                          = 81
  FistBumpRequestOnce                   = 82
  FistBumpRequestRetry                  = 83
  FistBumpSuccess                       = 84
  FistBumpLeftHanging                   = 85
  FlipDownFromBack                      = 86
  FrustratedByFailure                   = 87
  FrustratedByFailureMajor              = 88
  GameSetupGetIn                        = 89
  GameSetupGetOut                       = 90
  GameSetupIdle                         = 91
  GameSetupReaction                     = 92
  GoToSleepGetIn                        = 93
  GoToSleepGetOut                       = 94
  GoToSleepOff                          = 95
  GoToSleepSleeping                     = 96
  GuardDogBusted                        = 97
  GuardDogCubeDisconnect                = 98
  GuardDogFakeout                       = 99
  GuardDogInterruption                  = 100
  GuardDogPlayerSuccess                 = 101
  GuardDogPulse                         = 102
  GuardDogSettle                        = 103
  GuardDogSleepLoop                     = 104
  GuardDogTimeout                       = 105
  GuardDogTimeoutCubesTouched           = 106
  GuardDogTimeoutCubesUntouched         = 107
  Hiccup                                = 108
  HiccupGetIn                           = 109
  HiccupPlayerCure                      = 110
  HiccupRobotOnBack                     = 111
  HiccupRobotOnFace                     = 112
  HiccupRobotPickedUp                   = 113
  HiccupSelfCure                        = 114
  HikingDrivingEnd                      = 115
  HikingDrivingLoop                     = 116
  HikingDrivingStart                    = 117
  HikingInterestingEdgeThought          = 118
  HikingIntro                           = 119
  HikingLookAround                      = 120
  HikingObserve                         = 121
  HikingReactToEdge                     = 122
  HikingReactToNewArea                  = 123
  HikingReactToPossibleMarker           = 124
  HikingSquintEnd                       = 125
  HikingSquintLoop                      = 126
  HikingSquintStart                     = 127
  HikingWakeUpOffCharger                = 128
  IdleOnCharger                         = 129
  InteractWithFaceTrackingIdle          = 130
  InteractWithFacesInitialNamed         = 131
  InteractWithFacesInitialUnnamed       = 132
  KnockOverEyes                         = 133
  KnockOverFailure                      = 134
  KnockOverGrabAttempt                  = 135
  KnockOverPreActionNamedFace           = 136
  KnockOverPreActionUnnamedFace         = 137
  KnockOverSuccess                      = 138
  LookInPlaceForFacesBodyPause          = 139
  LookInPlaceForFacesHeadMovePause      = 140
  MajorFail                             = 141
  MajorWin                              = 142
  MeetCozmoGetIn                        = 143
  MeetCozmoLookFaceGetIn                = 144
  MeetCozmoLookFaceGetOut               = 145
  MeetCozmoScanningIdle                 = 146
  MeetCozmoFirstEnrollmentSayName       = 147
  MeetCozmoFirstEnrollmentRepeatName    = 148
  MeetCozmoFirstEnrollmentCelebration   = 149
  MeetCozmoReEnrollmentSayName          = 150
  MeetCozmoRenameFaceSayName            = 151
  MeetCozmoLookFaceInterrupt            = 152
  MemoryMatchPlayerWinHand              = 153
  MemoryMatchPlayerWinHandLong          = 154
  MemoryMatchPlayerWinHandSolo          = 155
  MemoryMatchPlayerLoseHand             = 156
  MemoryMatchPlayerLoseHandSolo         = 157
  MemoryMatchCozmoWinHand               = 158
  MemoryMatchCozmoLoseHand              = 159
  MemoryMatchCozmoWinGame               = 160
  MemoryMatchPlayerWinGame              = 161
  MemoryMatchSoloGameOver               = 162
  MemoryMatchReactToPattern             = 163
  MemoryMatchReactToPatternSolo         = 164
  MemoryMatchPointCenter                = 165
  MemoryMatchPointLeftBig               = 166
  MemoryMatchPointLeftSmall             = 167
  MemoryMatchPointRightBig              = 168
  MemoryMatchPointRightSmall            = 169
  MemoryMatchPointCenterFast            = 170
  MemoryMatchPointLeftBigFast           = 171
  MemoryMatchPointLeftSmallFast         = 172
  MemoryMatchPointRightBigFast          = 173
  MemoryMatchPointRightSmallFast        = 174
  MemoryMatchCozmoGetOut                = 175
  MemoryMatchCozmoFollowTapsSoundOnly   = 176
  NamedFaceInitialGreeting              = 177
  NeutralFace                           = 178
  NothingToDoBoredEvent                 = 179
  NothingToDoBoredIdle                  = 180
  NothingToDoBoredIntro                 = 181
  NothingToDoBoredOutro                 = 182
  OnLearnedPlayerName                   = 183
  OnSawNewNamedFace                     = 184
  OnSawNewUnnamedFace                   = 185
  OnSawOldNamedFace                     = 186
  OnSawOldUnnamedFace                   = 187
  OnSpeedtapCozmoConfirm                = 188
  OnSpeedtapFakeout                     = 189
  OnSpeedtapGameCozmoWinHighIntensity   = 190
  OnSpeedtapGameCozmoWinLowIntensity    = 191
  OnSpeedtapGamePlayerWinHighIntensity  = 192
  OnSpeedtapGamePlayerWinLowIntensity   = 193
  OnSpeedtapGetOut                      = 194
  OnSpeedtapHandCozmoWin                = 195
  OnSpeedtapHandPlayerWin               = 196
  OnSpeedtapIdle                        = 197
  OnSpeedtapRoundCozmoWinHighIntensity  = 198
  OnSpeedtapRoundCozmoWinLowIntensity   = 199
  OnSpeedtapRoundPlayerWinHighIntensity = 200
  OnSpeedtapRoundPlayerWinLowIntensity  = 201
  OnSpeedtapTap                         = 202
  OnWaitForCubesMinigameSetup           = 203
  OnWiggle                              = 204
  OnboardingBirth                       = 205
  OnboardingCubeDockFail                = 206
  OnboardingDiscoverCube                = 207
  OnboardingDriveEnd                    = 208
  OnboardingDriveLoop                   = 209
  OnboardingDriveStart                  = 210
  OnboardingEyesOn                      = 211
  OnboardingHelloPlayer                 = 212
  OnboardingHelloWorld                  = 213
  OnboardingIdle                        = 214
  OnboardingInteractWithCube            = 215
  OnboardingPreBirth                    = 216
  OnboardingReactToCube                 = 217
  OnboardingReactToCubePutDown          = 218
  OnboardingReactToFace                 = 219
  OnboardingSoundOnlyLiftEffortPickup   = 220
  OnboardingSoundOnlyLiftEffortPlaceLow = 221
  OnboardingGetOut                      = 222
  PeekABooGetIn                         = 223
  PeekABooGetOutHappy                   = 224
  PeekABooGetOutSad                     = 225
  PeekABooHighIntensity                 = 226
  PeekABooIdle                          = 227
  PeekABooLowIntensity                  = 228
  PeekABooMedIntensity                  = 229
  PeekABooNoUserInteraction             = 230
  PeekABooShort                         = 231
  PeekABooSurprised                     = 232
  PetDetectionCat                       = 233
  PetDetectionDog                       = 234
  PetDetectionShort                     = 235
  PetDetectionShort_Cat                 = 236
  PetDetectionShort_Dog                 = 237
  PetDetectionSneeze                    = 238
  PlacedOnCharger                       = 239
  PopAWheelieInitial                    = 240
  PopAWheeliePreActionNamedFace         = 241
  PopAWheeliePreActionUnnamedFace       = 242
  PopAWheelieRealign                    = 243
  PopAWheelieRetry                      = 244
  PounceDriveEnd                        = 245
  PounceDriveLoop                       = 246
  PounceDriveStart                      = 247
  PounceFace                            = 248
  PounceFail                            = 249
  PounceGetOut                          = 250
  PounceInitial                         = 251
  PouncePounce                          = 252
  PounceSuccess                         = 253
  ProceduralLive                        = 254
  PutDownBlockKeepAlive                 = 255
  PutDownBlockPutDown                   = 256
  ReactToBlockPickupSuccess             = 257
  ReactToBlockRetryPickup               = 258
  ReactToCliff                          = 259
  ReactToCliffDetectorStop              = 260
  ReactToMotorCalibration               = 261
  ReactToNewBlockAsk                    = 262
  ReactToNewBlockBig                    = 263
  ReactToNewBlockSmall                  = 264
  ReactToOnLeftSide                     = 265
  ReactToOnRightSide                    = 266
  ReactToPerchedOnBlock                 = 267
  ReactToPickup                         = 268
  ReactToPokeReaction                   = 269
  ReactToPokeStartled                   = 270
  ReactToUnexpectedMovement             = 271
  RequestGameDrivingFail                = 272
  RequestGameKeepAwayAccept0            = 273
  RequestGameKeepAwayAccept1            = 274
  RequestGameKeepAwayDeny0              = 275
  RequestGameKeepAwayDeny1              = 276
  RequestGameKeepAwayIdle0              = 277
  RequestGameKeepAwayIdle1              = 278
  RequestGameKeepAwayInitial0           = 279
  RequestGameKeepAwayInitial1           = 280
  RequestGameKeepAwayPreDrive0          = 281
  RequestGameKeepAwayPreDrive1          = 282
  RequestGameKeepAwayRequest0           = 283
  RequestGameKeepAwayRequest1           = 284
  RequestGameMemoryMatchAccept0         = 285
  RequestGameMemoryMatchAccept1         = 286
  RequestGameMemoryMatchDeny0           = 287
  RequestGameMemoryMatchDeny1           = 288
  RequestGameMemoryMatchIdle0           = 289
  RequestGameMemoryMatchIdle1           = 290
  RequestGameMemoryMatchInitial0        = 291
  RequestGameMemoryMatchInitial1        = 292
  RequestGameMemoryMatchPreDrive0       = 293
  RequestGameMemoryMatchPreDrive1       = 294
  RequestGameMemoryMatchRequest0        = 295
  RequestGameMemoryMatchRequest1        = 296
  RequestGamePickupFail                 = 297
  RequestGameSpeedTapAccept0            = 298
  RequestGameSpeedTapAccept1            = 299
  RequestGameSpeedTapDeny0              = 300
  RequestGameSpeedTapDeny1              = 301
  RequestGameSpeedTapIdle0              = 302
  RequestGameSpeedTapIdle1              = 303
  RequestGameSpeedTapInitial0           = 304
  RequestGameSpeedTapInitial1           = 305
  RequestGameSpeedTapPreDrive0          = 306
  RequestGameSpeedTapPreDrive1          = 307
  RequestGameSpeedTapRequest0           = 308
  RequestGameSpeedTapRequest1           = 309
  RollBlockInitial                      = 310
  RollBlockPreActionNamedFace           = 311
  RollBlockPreActionUnnamedFace         = 312
  RollBlockPutDown                      = 313
  RollBlockRealign                      = 314
  RollBlockRetry                        = 315
  RollBlockSuccess                      = 316
  SdkTextToSpeech                       = 317
  Shiver                                = 318
  Shocked                               = 319
  Sleeping                              = 320
  SoftSparkUpgradeLift                  = 321
  SoftSparkUpgradeTracks                = 322
  SoundOnlyLiftEffortPickup             = 323
  SoundOnlyLiftEffortPlaceHigh          = 324
  SoundOnlyLiftEffortPlaceLow           = 325
  SoundOnlyLiftEffortPlaceRoll          = 326
  SoundOnlyRamIntoBlock                 = 327
  SoundOnlyTurnSmall                    = 328
  SparkDrivingLoop                      = 329
  SparkDrivingStart                     = 330
  SparkDrivingStop                      = 331
  SparkFailure                          = 332
  SparkGetIn                            = 333
  SparkGetOut                           = 334
  SparkIdle                             = 335
  SparkPickupFinalCubeReaction          = 336
  SparkPickupInitialCubeReaction        = 337
  SparkSuccess                          = 338
  SpeedTapDrivingEnd                    = 339
  SpeedTapDrivingLoop                   = 340
  SpeedTapDrivingStart                  = 341
  StackBlocksPreActionNamedFace         = 342
  StackBlocksPreActionUnnamedFace       = 343
  StackBlocksRetry                      = 344
  StackBlocksSuccess                    = 345
  StartSleeping                         = 346
  SuccessfulWheelie                     = 347
  Surprise                              = 348
  TurtleRoll                            = 349
  UnitTestAnim                          = 350
  WaitOnSideLoop                        = 351
  WorkoutPostLift_highEnergy            = 352
  WorkoutPostLift_lowEnergy             = 353
  WorkoutPostLift_mediumEnergy          = 354
  WorkoutPreLift_highEnergy             = 355
  WorkoutPreLift_lowEnergy              = 356
  WorkoutPreLift_mediumEnergy           = 357
  WorkoutPutDown_highEnergy             = 358
  WorkoutPutDown_lowEnergy              = 359
  WorkoutPutDown_lowEnergy_simple       = 360
  WorkoutPutDown_mediumEnergy           = 361
  WorkoutStrongLift_highEnergy          = 362
  WorkoutStrongLift_lowEnergy           = 363
  WorkoutStrongLift_mediumEnergy        = 364
  WorkoutTransition_highEnergy          = 365
  WorkoutTransition_lowEnergy           = 366
  WorkoutTransition_mediumEnergy        = 367
  WorkoutWeakLift_highEnergy            = 368
  WorkoutWeakLift_lowEnergy             = 369
  WorkoutWeakLift_mediumEnergy          = 370
  Count                                 = 371

Anki.Cozmo.AnimationTrigger = AnimationTrigger
del AnimationTrigger


class CubeAnimationTrigger(object):
  "Automatically-generated int_32 enumeration."
  Carrying                    = 0
  Connected                   = 1
  CubePouncePlayerLose        = 2
  CubePouncePlayerWin         = 3
  DoubleTappedKnown           = 4
  DoubleTappedUnsure          = 5
  DrivingTo                   = 6
  Flash                       = 7
  GatherCubesAllCubesInBeacon = 8
  GatherCubesCubeInBeacon     = 9
  GuardDogBeingMoved          = 10
  GuardDogBusted              = 11
  GuardDogOff                 = 12
  GuardDogPulse               = 13
  GuardDogSleeping            = 14
  GuardDogSuccessfullyFlipped = 15
  Interacting                 = 16
  InteractingBehaviorLock     = 17
  Onboarding                  = 18
  PyramidBaseBottom           = 19
  PyramidFlourish             = 20
  PyramidOnSideLocated        = 21
  PyramidOnSideNotLocated     = 22
  PyramidPickup               = 23
  PyramidSingle               = 24
  Sleep                       = 25
  SleepNoFade                 = 26
  SpeedTapWin                 = 27
  SpeedTapLose                = 28
  Visible                     = 29
  WakeUp                      = 30
  Workout                     = 31
  Count                       = 32

Anki.Cozmo.CubeAnimationTrigger = CubeAnimationTrigger
del CubeAnimationTrigger


