# Copyright (c) 2016 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/behaviorTypes.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ -o ../generated/cladPython// clad/types/behaviorTypes.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class BehaviorGameFlag(object):
  "Automatically-generated uint_8 enumeration."
  NoGame      = 0
  SpeedTap    = 0x1
  MemoryMatch = 0x2
  KeepAway    = 0x4
  All         = 0xff

Anki.Cozmo.BehaviorGameFlag = BehaviorGameFlag
del BehaviorGameFlag


class BehaviorClass(object):
  "Automatically-generated uint_8 enumeration."
  NoneBehavior               = 0
  BringCubeToBeacon          = 1
  BuildPyramid               = 2
  BuildPyramidBase           = 3
  CantHandleTallStack        = 4
  CheckForStackAtInterval    = 5
  CubeLiftWorkout            = 6
  DockingTestSimple          = 7
  DriveOffCharger            = 8
  DrivePath                  = 9
  EnrollFace                 = 10
  ExploreLookAroundInPlace   = 11
  ExploreVisitPossibleMarker = 12
  FactoryCentroidExtractor   = 13
  FactoryTest                = 14
  FindFaces                  = 15
  FistBump                   = 16
  GuardDog                   = 17
  InteractWithFaces          = 18
  KnockOverCubes             = 19
  LiftLoadTest               = 20
  LookAround                 = 21
  LookForFaceAndCube         = 22
  LookInPlaceMemoryMap       = 23
  OnConfigSeen               = 24
  OnboardingShowCube         = 25
  PeekABoo                   = 26
  PickUpCube                 = 27
  PickUpAndPutDownCube       = 28
  PlayAnim                   = 29
  PlayArbitraryAnim          = 30
  PopAWheelie                = 31
  PounceOnMotion             = 32
  PutDownBlock               = 33
  PyramidThankYou            = 34
  RespondPossiblyRoll        = 35
  RespondToRenameFace        = 36
  RequestGameSimple          = 37
  RollBlock                  = 38
  StackBlocks                = 39
  ThinkAboutBeacons          = 40
  VisitInterestingEdge       = 41
  AcknowledgeFace            = 42
  AcknowledgeObject          = 43
  RamIntoBlock               = 44
  ReactToCliff               = 45
  ReactToCubeMoved           = 46
  ReactToDoubleTap           = 47
  ReactToFrustration         = 48
  ReactToMotorCalibration    = 49
  ReactToOnCharger           = 50
  ReactToPet                 = 51
  ReactToPickup              = 52
  ReactToPlacedOnSlope       = 53
  ReactToPyramid             = 54
  ReactToReturnedToTreads    = 55
  ReactToRobotOnBack         = 56
  ReactToRobotOnFace         = 57
  ReactToRobotOnSide         = 58
  ReactToRobotShaken         = 59
  ReactToSparked             = 60
  ReactToStackOfCubes        = 61
  ReactToUnexpectedMovement  = 62
  Count                      = 63

Anki.Cozmo.BehaviorClass = BehaviorClass
del BehaviorClass


class ExecutableBehaviorType(object):
  "Automatically-generated uint_8 enumeration."
  NoneBehavior      = 0
  FindFaces         = 1
  FistBump          = 2
  KnockOverCubes    = 3
  LiftLoadTest      = 4
  LookAroundInPlace = 5
  PounceOnMotion    = 6
  RollBlock         = 7
  StackBlocks       = 8
  EnrollFace        = 9
  Count             = 10

Anki.Cozmo.ExecutableBehaviorType = ExecutableBehaviorType
del ExecutableBehaviorType


