# Copyright (c) 2016 Anki, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License in the file LICENSE.txt or at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Autogenerated python message buffer code.
Source: clad/types/visionModes.clad
Full command line: ../tools/message-buffers/emitters/Python_emitter.py -C ./src/ -I ../robot/clad/src/ ../coretech/vision/clad/src/ ../coretech/common/clad/src/ -o ../generated/cladPython// clad/types/visionModes.clad
"""

from __future__ import absolute_import
from __future__ import print_function

def _modify_path():
  import inspect, os, sys
  search_paths = [
    '../..',
    '../../../../tools/message-buffers/support/python',
  ]
  currentpath = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
  for search_path in search_paths:
    search_path = os.path.normpath(os.path.abspath(os.path.realpath(os.path.join(currentpath, search_path))))
    if search_path not in sys.path:
      sys.path.insert(0, search_path)
_modify_path()

import msgbuffers

Anki = msgbuffers.Namespace()
Anki.Cozmo = msgbuffers.Namespace()

class VisionMode(object):
  "Automatically-generated uint_16 enumeration."
  Idle                       = 0x0
  DetectingMarkers           = 0x0 + 1
  Tracking                   = 0x0 + 2
  DetectingFaces             = 0x0 + 3
  DetectingMotion            = 0x0 + 4
  DetectingOverheadEdges     = 0x0 + 5
  ReadingToolCode            = 0x0 + 6
  ComputingCalibration       = 0x0 + 7
  CheckingQuality            = 0x0 + 8
  DetectingPets              = 0x0 + 9
  EstimatingFacialExpression = 0x0 + 10
  DetectingSmileAmount       = 0x0 + 11
  DetectingGaze              = 0x0 + 12
  DetectingBlinkAmount       = 0x0 + 13
  LimitedExposure            = 0x0 + 14
  Count                      = 0x0 + 15

Anki.Cozmo.VisionMode = VisionMode
del VisionMode


